
# ===========================================================
#             Copyright (C) 2023-present AyiinXd
# ===========================================================
# ||                                                       ||
# ||              _         _ _      __  __   _            ||
# ||             /   _   _(_|_)_ __  / /__| |           ||
# ||            / _ | | | | | | '_     _  | |           ||
# ||           / ___  |_| | | | | | |/   (_| |           ||
# ||          /_/   ___, |_|_|_| |_/_/___,_|           ||
# ||                  |___/                                ||
# ||                                                       ||
# ===========================================================
#  Appreciating the work of others is not detrimental to you
# ===========================================================
# 

from .getMessages import GetMessages
from .getDialogs import GetDialogs
from .getHistory import GetHistory
from .search import Search
from .readHistory import ReadHistory
from .deleteHistory import DeleteHistory
from .deleteMessages import DeleteMessages
from .receivedMessages import ReceivedMessages
from .setTyping import SetTyping
from .sendMessage import SendMessage
from .sendMedia import SendMedia
from .forwardMessages import ForwardMessages
from .reportSpam import ReportSpam
from .getPeerSettings import GetPeerSettings
from .report import Report
from .getChats import GetChats
from .getFullChat import GetFullChat
from .editChatTitle import EditChatTitle
from .editChatPhoto import EditChatPhoto
from .addChatUser import AddChatUser
from .deleteChatUser import DeleteChatUser
from .createChat import CreateChat
from .getDhConfig import GetDhConfig
from .requestEncryption import RequestEncryption
from .acceptEncryption import AcceptEncryption
from .discardEncryption import DiscardEncryption
from .setEncryptedTyping import SetEncryptedTyping
from .readEncryptedHistory import ReadEncryptedHistory
from .sendEncrypted import SendEncrypted
from .sendEncryptedFile import SendEncryptedFile
from .sendEncryptedService import SendEncryptedService
from .receivedQueue import ReceivedQueue
from .reportEncryptedSpam import ReportEncryptedSpam
from .readMessageContents import ReadMessageContents
from .getStickers import GetStickers
from .getAllStickers import GetAllStickers
from .getWebPagePreview import GetWebPagePreview
from .exportChatInvite import ExportChatInvite
from .checkChatInvite import CheckChatInvite
from .importChatInvite import ImportChatInvite
from .getStickerSet import GetStickerSet
from .installStickerSet import InstallStickerSet
from .uninstallStickerSet import UninstallStickerSet
from .startBot import StartBot
from .getMessagesViews import GetMessagesViews
from .editChatAdmin import EditChatAdmin
from .migrateChat import MigrateChat
from .searchGlobal import SearchGlobal
from .reorderStickerSets import ReorderStickerSets
from .getDocumentByHash import GetDocumentByHash
from .getSavedGifs import GetSavedGifs
from .saveGif import SaveGif
from .getInlineBotResults import GetInlineBotResults
from .setInlineBotResults import SetInlineBotResults
from .sendInlineBotResult import SendInlineBotResult
from .getMessageEditData import GetMessageEditData
from .editMessage import EditMessage
from .editInlineBotMessage import EditInlineBotMessage
from .getBotCallbackAnswer import GetBotCallbackAnswer
from .setBotCallbackAnswer import SetBotCallbackAnswer
from .getPeerDialogs import GetPeerDialogs
from .saveDraft import SaveDraft
from .getFeaturedStickers import GetFeaturedStickers
from .readFeaturedStickers import ReadFeaturedStickers
from .getRecentStickers import GetRecentStickers
from .saveRecentSticker import SaveRecentSticker
from .clearRecentStickers import ClearRecentStickers
from .getArchivedStickers import GetArchivedStickers
from .getMaskStickers import GetMaskStickers
from .getAttachedStickers import GetAttachedStickers
from .setGameScore import SetGameScore
from .setInlineGameScore import SetInlineGameScore
from .getGameHighScores import GetGameHighScores
from .getInlineGameHighScores import GetInlineGameHighScores
from .getCommonChats import GetCommonChats
from .getWebPage import GetWebPage
from .toggleDialogPin import ToggleDialogPin
from .reorderPinnedDialogs import ReorderPinnedDialogs
from .getPinnedDialogs import GetPinnedDialogs
from .setBotShippingResults import SetBotShippingResults
from .setBotPrecheckoutResults import SetBotPrecheckoutResults
from .uploadMedia import UploadMedia
from .sendScreenshotNotification import SendScreenshotNotification
from .getFavedStickers import GetFavedStickers
from .faveSticker import FaveSticker
from .getUnreadMentions import GetUnreadMentions
from .readMentions import ReadMentions
from .getRecentLocations import GetRecentLocations
from .sendMultiMedia import SendMultiMedia
from .uploadEncryptedFile import UploadEncryptedFile
from .searchStickerSets import SearchStickerSets
from .markDialogUnread import MarkDialogUnread
from .updatePinnedMessage import UpdatePinnedMessage
from .sendVote import SendVote
from .getPollResults import GetPollResults
from .getOnlines import GetOnlines
from .editChatAbout import EditChatAbout
from .editChatDefaultBannedRights import EditChatDefaultBannedRights
from .getEmojiKeywords import GetEmojiKeywords
from .getEmojiKeywordsDifference import GetEmojiKeywordsDifference
from .getEmojiKeywordsLanguages import GetEmojiKeywordsLanguages
from .getEmojiURL import GetEmojiURL
from .getSearchCounters import GetSearchCounters
from .requestUrlAuth import RequestUrlAuth
from .acceptUrlAuth import AcceptUrlAuth
from .hidePeerSettingsBar import HidePeerSettingsBar
from .getScheduledHistory import GetScheduledHistory
from .getScheduledMessages import GetScheduledMessages
from .sendScheduledMessages import SendScheduledMessages
from .deleteScheduledMessages import DeleteScheduledMessages
from .getPollVotes import GetPollVotes
from .toggleStickerSets import ToggleStickerSets
from .updateDialogFilter import UpdateDialogFilter
from .updateDialogFiltersOrder import UpdateDialogFiltersOrder
from .getOldFeaturedStickers import GetOldFeaturedStickers
from .getReplies import GetReplies
from .getDiscussionMessage import GetDiscussionMessage
from .readDiscussion import ReadDiscussion
from .unpinAllMessages import UnpinAllMessages
from .deleteChat import DeleteChat
from .deletePhoneCallHistory import DeletePhoneCallHistory
from .checkHistoryImport import CheckHistoryImport
from .initHistoryImport import InitHistoryImport
from .uploadImportedMedia import UploadImportedMedia
from .startHistoryImport import StartHistoryImport
from .getExportedChatInvites import GetExportedChatInvites
from .getExportedChatInvite import GetExportedChatInvite
from .editExportedChatInvite import EditExportedChatInvite
from .deleteRevokedExportedChatInvites import DeleteRevokedExportedChatInvites
from .deleteExportedChatInvite import DeleteExportedChatInvite
from .getAdminsWithInvites import GetAdminsWithInvites
from .getChatInviteImporters import GetChatInviteImporters
from .setHistoryTTL import SetHistoryTTL
from .checkHistoryImportPeer import CheckHistoryImportPeer
from .setChatTheme import SetChatTheme
from .getMessageReadParticipants import GetMessageReadParticipants
from .getSearchResultsCalendar import GetSearchResultsCalendar
from .getSearchResultsPositions import GetSearchResultsPositions
from .hideChatJoinRequest import HideChatJoinRequest
from .hideAllChatJoinRequests import HideAllChatJoinRequests
from .toggleNoForwards import ToggleNoForwards
from .saveDefaultSendAs import SaveDefaultSendAs
from .sendReaction import SendReaction
from .getMessagesReactions import GetMessagesReactions
from .getMessageReactionsList import GetMessageReactionsList
from .setChatAvailableReactions import SetChatAvailableReactions
from .getAvailableReactions import GetAvailableReactions
from .setDefaultReaction import SetDefaultReaction
from .translateText import TranslateText
from .getUnreadReactions import GetUnreadReactions
from .readReactions import ReadReactions
from .searchSentMedia import SearchSentMedia
from .getAttachMenuBots import GetAttachMenuBots
from .getAttachMenuBot import GetAttachMenuBot
from .toggleBotInAttachMenu import ToggleBotInAttachMenu
from .requestWebView import RequestWebView
from .prolongWebView import ProlongWebView
from .requestSimpleWebView import RequestSimpleWebView
from .sendWebViewResultMessage import SendWebViewResultMessage
from .sendWebViewData import SendWebViewData
from .transcribeAudio import TranscribeAudio
from .rateTranscribedAudio import RateTranscribedAudio
from .getCustomEmojiDocuments import GetCustomEmojiDocuments
from .getEmojiStickers import GetEmojiStickers
from .getFeaturedEmojiStickers import GetFeaturedEmojiStickers
from .reportReaction import ReportReaction
from .getTopReactions import GetTopReactions
from .getRecentReactions import GetRecentReactions
from .getExtendedMedia import GetExtendedMedia
from .setDefaultHistoryTTL import SetDefaultHistoryTTL
from .sendBotRequestedPeer import SendBotRequestedPeer
from .getEmojiGroups import GetEmojiGroups
from .getEmojiStatusGroups import GetEmojiStatusGroups
from .getEmojiProfilePhotoGroups import GetEmojiProfilePhotoGroups
from .searchCustomEmoji import SearchCustomEmoji
from .togglePeerTranslations import TogglePeerTranslations
from .getBotApp import GetBotApp
from .requestAppWebView import RequestAppWebView
from .setChatWallPaper import SetChatWallPaper
from .searchEmojiStickerSets import SearchEmojiStickerSets
from .getSavedDialogs import GetSavedDialogs
from .getSavedHistory import GetSavedHistory
from .deleteSavedHistory import DeleteSavedHistory
from .toggleSavedDialogPin import ToggleSavedDialogPin
from .reorderPinnedSavedDialogs import ReorderPinnedSavedDialogs
from .getSavedReactionTags import GetSavedReactionTags
from .updateSavedReactionTag import UpdateSavedReactionTag
from .getDefaultTagReactions import GetDefaultTagReactions
from .getOutboxReadDate import GetOutboxReadDate
from .getQuickReplies import GetQuickReplies
from .reorderQuickReplies import ReorderQuickReplies
from .checkQuickReplyShortcut import CheckQuickReplyShortcut
from .editQuickReplyShortcut import EditQuickReplyShortcut
from .deleteQuickReplyShortcut import DeleteQuickReplyShortcut
from .getQuickReplyMessages import GetQuickReplyMessages
from .sendQuickReplyMessages import SendQuickReplyMessages
from .deleteQuickReplyMessages import DeleteQuickReplyMessages
from .toggleDialogFilterTags import ToggleDialogFilterTags
from .getMyStickers import GetMyStickers
from .getEmojiStickerGroups import GetEmojiStickerGroups
from .getAvailableEffects import GetAvailableEffects
from .editFactCheck import EditFactCheck
from .deleteFactCheck import DeleteFactCheck
from .getFactCheck import GetFactCheck
