
# ===========================================================
#             Copyright (C) 2023-present AyiinXd
# ===========================================================
# ||                                                       ||
# ||              _         _ _      __  __   _            ||
# ||             /   _   _(_|_)_ __  / /__| |           ||
# ||            / _ | | | | | | '_     _  | |           ||
# ||           / ___  |_| | | | | | |/   (_| |           ||
# ||          /_/   ___, |_|_|_| |_/_/___,_|           ||
# ||                  |___/                                ||
# ||                                                       ||
# ===========================================================
#  Appreciating the work of others is not detrimental to you
# ===========================================================
# 

from .seeOther import (
    FileMigrateX,
    NetworkMigrateX,
    PhoneMigrateX,
    StatsMigrateX,
    UserMigrateX,
)
from .badRequest import (
    AboutTooLong,
    AccessTokenExpired,
    AccessTokenInvalid,
    AdminsTooMuch,
    AdminRankEmojiNotAllowed,
    AdminRankInvalid,
    AlbumPhotosTooMany,
    ApiIdInvalid,
    ApiIdPublishedFlood,
    ArticleTitleEmpty,
    AudioTitleEmpty,
    AuthBytesInvalid,
    AuthTokenAlreadyAccepted,
    AuthTokenExpired,
    AuthTokenInvalid,
    AutoarchiveNotAvailable,
    BankCardNumberInvalid,
    BannedRightsInvalid,
    BasePortLocInvalid,
    BotsTooMuch,
    BotChannelsNa,
    BotCommandDescriptionInvalid,
    BotDomainInvalid,
    BotGamesDisabled,
    BotGroupsBlocked,
    BotInlineDisabled,
    BotInvalid,
    BotMethodInvalid,
    BotMissing,
    BotOnesideNotAvail,
    BotPaymentsDisabled,
    BotPollsDisabled,
    BotResponseTimeout,
    BotScoreNotModified,
    BroadcastIdInvalid,
    BroadcastPublicVotersForbidden,
    BroadcastRequired,
    ButtonDataInvalid,
    ButtonTypeInvalid,
    ButtonUrlInvalid,
    ButtonUserPrivacyRestricted,
    CallAlreadyAccepted,
    CallAlreadyDeclined,
    CallPeerInvalid,
    CallProtocolFlagsInvalid,
    CdnMethodInvalid,
    ChannelsAdminPublicTooMuch,
    ChannelsTooMuch,
    ChannelAddInvalid,
    ChannelBanned,
    ChannelInvalid,
    ChannelPrivate,
    ChannelTooLarge,
    ChatAboutNotModified,
    ChatAboutTooLong,
    ChatAdminRequired,
    ChatForwardsRestricted,
    ChatIdEmpty,
    ChatIdInvalid,
    ChatInvalid,
    ChatInvitePermanent,
    ChatLinkExists,
    ChatNotModified,
    ChatRestricted,
    ChatSendInlineForbidden,
    ChatTitleEmpty,
    ChatTooBig,
    CodeEmpty,
    CodeHashInvalid,
    CodeInvalid,
    ConnectionApiIdInvalid,
    ConnectionAppVersionEmpty,
    ConnectionDeviceModelEmpty,
    ConnectionLangPackInvalid,
    ConnectionLayerInvalid,
    ConnectionNotInited,
    ConnectionSystemEmpty,
    ConnectionSystemLangCodeEmpty,
    ContactAddMissing,
    ContactIdInvalid,
    ContactNameEmpty,
    ContactReqMissing,
    DataInvalid,
    DataJsonInvalid,
    DataTooLong,
    DateEmpty,
    DcIdInvalid,
    DhGAInvalid,
    DocumentInvalid,
    EmailHashExpired,
    EmailInvalid,
    EmailUnconfirmed,
    EmailUnconfirmedX,
    EmailVerifyExpired,
    EmoticonEmpty,
    EmoticonInvalid,
    EmoticonStickerpackMissing,
    EncryptedMessageInvalid,
    EncryptionAlreadyAccepted,
    EncryptionAlreadyDeclined,
    EncryptionDeclined,
    EncryptionIdInvalid,
    EntitiesTooLong,
    EntityBoundsInvalid,
    EntityMentionUserInvalid,
    ErrorTextEmpty,
    ExpireDateInvalid,
    ExportCardInvalid,
    ExternalUrlInvalid,
    FieldNameEmpty,
    FieldNameInvalid,
    FileIdInvalid,
    FileMigrateX,
    FilePartsInvalid,
    FilePartEmpty,
    FilePartInvalid,
    FilePartLengthInvalid,
    FilePartSizeChanged,
    FilePartSizeInvalid,
    FilePartTooBig,
    FilePartXMissing,
    FileReferenceEmpty,
    FileReferenceExpired,
    FileReferenceInvalid,
    FilterIdInvalid,
    FirstnameInvalid,
    FolderIdEmpty,
    FolderIdInvalid,
    FreshChangeAdminsForbidden,
    FromMessageBotDisabled,
    FromPeerInvalid,
    GameBotInvalid,
    GeoPointInvalid,
    GifContentTypeInvalid,
    GifIdInvalid,
    GraphInvalidReload,
    GraphOutdatedReload,
    GroupcallSsrcDuplicateMuch,
    GroupedMediaInvalid,
    GroupCallInvalid,
    HashInvalid,
    ImageProcessFailed,
    ImportFileInvalid,
    ImportFormatUnrecognized,
    ImportIdInvalid,
    InlineResultExpired,
    InputConstructorInvalid,
    InputFetchError,
    InputFetchFail,
    InputFilterInvalid,
    InputLayerInvalid,
    InputMethodInvalid,
    InputRequestTooLong,
    InputUserDeactivated,
    InviteHashEmpty,
    InviteHashExpired,
    InviteHashInvalid,
    InviteRequestSent,
    InviteRevokedMissing,
    LangPackInvalid,
    LastnameInvalid,
    LimitInvalid,
    LinkNotModified,
    LocationInvalid,
    MaxIdInvalid,
    MaxQtsInvalid,
    Md5ChecksumInvalid,
    MediaCaptionTooLong,
    MediaEmpty,
    MediaInvalid,
    MediaNewInvalid,
    MediaPrevInvalid,
    MegagroupIdInvalid,
    MegagroupPrehistoryHidden,
    MegagroupRequired,
    MessageEditTimeExpired,
    MessageEmpty,
    MessageIdsEmpty,
    MessageIdInvalid,
    MessageNotModified,
    MessagePollClosed,
    MessageTooLong,
    MethodInvalid,
    MsgIdInvalid,
    MsgWaitFailed,
    MultiMediaTooLong,
    NewSaltInvalid,
    NewSettingsInvalid,
    NextOffsetInvalid,
    OffsetInvalid,
    OffsetPeerIdInvalid,
    OptionsTooMuch,
    OptionInvalid,
    PackShortNameInvalid,
    PackShortNameOccupied,
    PackTitleInvalid,
    ParticipantsTooFew,
    ParticipantVersionOutdated,
    PasswordEmpty,
    PasswordHashInvalid,
    PasswordMissing,
    PasswordRecoveryNa,
    PasswordRequired,
    PasswordTooFreshX,
    PaymentProviderInvalid,
    PeerFlood,
    PeerIdInvalid,
    PeerIdNotSupported,
    PersistentTimestampEmpty,
    PersistentTimestampInvalid,
    PhoneCodeEmpty,
    PhoneCodeExpired,
    PhoneCodeHashEmpty,
    PhoneCodeInvalid,
    PhoneNumberAppSignupForbidden,
    PhoneNumberBanned,
    PhoneNumberFlood,
    PhoneNumberInvalid,
    PhoneNumberOccupied,
    PhoneNumberUnoccupied,
    PhonePasswordProtected,
    PhotoContentTypeInvalid,
    PhotoContentUrlEmpty,
    PhotoCropFileMissing,
    PhotoCropSizeSmall,
    PhotoExtInvalid,
    PhotoFileMissing,
    PhotoIdInvalid,
    PhotoInvalid,
    PhotoInvalidDimensions,
    PhotoSaveFileInvalid,
    PhotoThumbUrlEmpty,
    PhotoThumbUrlInvalid,
    PinnedDialogsTooMuch,
    PinRestricted,
    PollAnswersInvalid,
    PollOptionDuplicate,
    PollOptionInvalid,
    PollQuestionInvalid,
    PollUnsupported,
    PollVoteRequired,
    PrivacyKeyInvalid,
    PrivacyTooLong,
    PrivacyValueInvalid,
    QueryIdEmpty,
    QueryIdInvalid,
    QueryTooShort,
    QuizCorrectAnswersEmpty,
    QuizCorrectAnswersTooMuch,
    QuizCorrectAnswerInvalid,
    QuizMultipleInvalid,
    RandomIdEmpty,
    RandomIdInvalid,
    RandomLengthInvalid,
    RangesInvalid,
    ReactionEmpty,
    ReactionInvalid,
    ReflectorNotAvailable,
    ReplyMarkupBuyEmpty,
    ReplyMarkupGameEmpty,
    ReplyMarkupInvalid,
    ReplyMarkupTooLong,
    ResultsTooMuch,
    ResultIdDuplicate,
    ResultIdEmpty,
    ResultIdInvalid,
    ResultTypeInvalid,
    RevoteNotAllowed,
    RsaDecryptFailed,
    ScheduleBotNotAllowed,
    ScheduleDateInvalid,
    ScheduleDateTooLate,
    ScheduleStatusPrivate,
    ScheduleTooMuch,
    SearchQueryEmpty,
    SecondsInvalid,
    SendMessageMediaInvalid,
    SendMessageTypeInvalid,
    SessionTooFreshX,
    SettingsInvalid,
    Sha256HashInvalid,
    ShortnameOccupyFailed,
    SlowmodeMultiMsgsDisabled,
    SmsCodeCreateFailed,
    SrpIdInvalid,
    SrpPasswordChanged,
    StartParamEmpty,
    StartParamInvalid,
    StartParamTooLong,
    StickersetInvalid,
    StickersetNotModified,
    StickersEmpty,
    StickersTooMuch,
    StickerDocumentInvalid,
    StickerEmojiInvalid,
    StickerFileInvalid,
    StickerIdInvalid,
    StickerInvalid,
    StickerPngDimensions,
    StickerPngNopng,
    StickerTgsNotgs,
    StickerThumbPngNopng,
    StickerVideoNowebm,
    TakeoutInvalid,
    TakeoutRequired,
    TempAuthKeyEmpty,
    ThemeFileInvalid,
    ThemeFormatInvalid,
    ThemeInvalid,
    ThemeMimeInvalid,
    TmpPasswordDisabled,
    TmpPasswordInvalid,
    TokenInvalid,
    TtlDaysInvalid,
    TtlMediaInvalid,
    TypesEmpty,
    TypeConstructorInvalid,
    UntilDateInvalid,
    UrlInvalid,
    UsageLimitInvalid,
    UsernameInvalid,
    UsernameNotModified,
    UsernameNotOccupied,
    UsernameOccupied,
    UserpicUploadRequired,
    UsersTooFew,
    UsersTooMuch,
    UserAdminInvalid,
    UserAlreadyParticipant,
    UserBannedInChannel,
    UserBlocked,
    UserBot,
    UserBotInvalid,
    UserBotRequired,
    UserChannelsTooMuch,
    UserCreator,
    UserIdInvalid,
    UserInvalid,
    UserIsBlocked,
    UserIsBot,
    UserKicked,
    UserNotMutualContact,
    UserNotParticipant,
    VideoContentTypeInvalid,
    VideoFileInvalid,
    VoiceMessagesForbidden,
    VolumeLocNotFound,
    WallpaperFileInvalid,
    WallpaperInvalid,
    WallpaperMimeInvalid,
    WcConvertUrlInvalid,
    WebdocumentInvalid,
    WebdocumentMimeInvalid,
    WebdocumentSizeTooBig,
    WebdocumentUrlEmpty,
    WebdocumentUrlInvalid,
    WebpageCurlFailed,
    WebpageMediaEmpty,
    YouBlockedUser,
)
from .unauthorized import (
    ActiveUserRequired,
    AuthKeyInvalid,
    AuthKeyPermEmpty,
    AuthKeyUnregistered,
    SessionExpired,
    SessionPasswordNeeded,
    SessionRevoked,
    UserDeactivated,
    UserDeactivatedBan,
)
from .forbidden import (
    BroadcastForbidden,
    ChannelPublicGroupNa,
    ChatAdminInviteRequired,
    ChatAdminRequired,
    ChatForbidden,
    ChatSendGifsForbidden,
    ChatSendInlineForbidden,
    ChatSendMediaForbidden,
    ChatSendPollForbidden,
    ChatSendStickersForbidden,
    ChatWriteForbidden,
    EditBotInviteForbidden,
    InlineBotRequired,
    MessageAuthorRequired,
    MessageDeleteForbidden,
    PollVoteRequired,
    PremiumAccountRequired,
    RightForbidden,
    SensitiveChangeForbidden,
    TakeoutRequired,
    UserBotInvalid,
    UserChannelsTooMuch,
    UserInvalid,
    UserIsBlocked,
    UserNotMutualContact,
    UserPrivacyRestricted,
    UserRestricted,
)
from .notAcceptable import (
    AuthKeyDuplicated,
    ChannelPrivate,
    FilerefUpgradeNeeded,
    FreshChangeAdminsForbidden,
    FreshChangePhoneForbidden,
    FreshResetAuthorisationForbidden,
    PhoneNumberInvalid,
    PhonePasswordFlood,
    StickersetInvalid,
    StickersetOwnerAnonymous,
    UserpicUploadRequired,
    UserRestricted,
)
from .tooMuchRequests import (
    F2aConfirmWaitX,
    FloodTestPhoneWaitX,
    FloodWaitX,
    SlowmodeWaitX,
    TakeoutInitDelayX,
)
from .internalServer import (
    ApiCallError,
    AuthRestart,
    CallOccupyFailed,
    ChatIdGenerateFailed,
    ChatOccupyLocFailed,
    ChatOccupyUsernameFailed,
    ChpCallFail,
    EncryptionOccupyAdminFailed,
    EncryptionOccupyFailed,
    FolderDeacAutofixAll,
    GroupcallAddParticipantsFailed,
    GroupedIdOccupyFailed,
    HistoryGetFailed,
    ImageEngineDown,
    InterdcXCallError,
    InterdcXCallRichError,
    MemberFetchFailed,
    MemberNoLocation,
    MemberOccupyPrimaryLocFailed,
    MemberOccupyUsernameFailed,
    MsgidDecreaseRetry,
    MsgRangeUnsync,
    MtSendQueueTooLong,
    NeedChatInvalid,
    NeedMemberInvalid,
    NoWorkersRunning,
    ParticipantCallFailed,
    PersistentTimestampOutdated,
    PhotoCreateFailed,
    PostponedTimeout,
    PtsChangeEmpty,
    RandomIdDuplicate,
    RegIdGenerateFailed,
    RpcCallFail,
    RpcConnectFailed,
    RpcMcgetFail,
    SignInFailed,
    StorageCheckFailed,
    StoreInvalidScalarType,
    UnknownMethod,
    UploadNoVolume,
    VolumeLocNotFound,
    WorkerBusyTooLongRetry,
    WpIdGenerateFailed,
)
from .serviceUnavailable import (
    ApiCallError,
    Timeout,
)
